AddCSLuaFile( "cl_init.lua" )
AddCSLuaFile( "shared.lua" )

ENT.WireDebugName = "Freezer"

include('shared.lua')

function ENT:Initialize()
	self.Entity:PhysicsInit( SOLID_VPHYSICS )
	self.Entity:SetMoveType( MOVETYPE_VPHYSICS )
	self.Entity:SetSolid( SOLID_VPHYSICS )
	
	self.Activated = 0
	self.AlterWeight = 1
	
	self.Inputs = Wire_CreateInputs( self.Entity, { "Activate" } )
	self.PreviousValue = 0
end

function ENT:OnRemove()
	local entInfo, i
	for i in pairs(self.EntInfo) do
		entInfo = self.EntInfo[i]
		self.Activated = 0
	      if self.AlterWeight == 1 then entInfo.Ent:GetPhysicsObject():SetMass(entInfo.OffWeight) end
	end
	Wire_Remove(self.Entity)
end

function ENT:SendVars( EntInfo )
	self.EntInfo = EntInfo
end

function ENT:Setup(alterweight)
	self.AlterWeight = alterweight
end

function ENT:TriggerInput(iname, value)
	if (iname == "Activate") then
		if (!self.EntInfo) then return end
	
		if ( value == 0 ) then
			local entInfo, i
			for i in pairs(self.EntInfo) do
				entInfo = self.EntInfo[i]
				entInfo.Ent:GetPhysicsObject():EnableMotion( true )
				entInfo.Ent:GetPhysicsObject():Wake()
				entInfo.Ent:GetPhysicsObject():EnableDrag( true )
	            	if self.AlterWeight == 1 then entInfo.Ent:GetPhysicsObject():SetMass(entInfo.OffWeight) end
			end
			self.Activated = 0
		end
		
		if ( value != 0 ) then
			local entInfo, i
			if self.AlterWeight == 1 then 
				for i in pairs(self.EntInfo) do
					entInfo = self.EntInfo[i]
					if (self.PreviousValue == 0 && entInfo.Ent:GetPhysicsObject():GetMass() != 50000) then
						entInfo.OffWeight = entInfo.Ent:GetPhysicsObject():GetMass()
					end
				end
			end
			self.Activated  = 1
		end
		self.PreviousValue = value
	end
end

function ENT:ShowOutput()
	local text = "Freezer - Deactivated"
	if self.Activated == 1 then
		text = "Freezer - Activated"
	end
	self:SetOverlayText( text )
end
	
function ENT:Think()
	if(self.Activated != 0) then
		if (!self.EntInfo) then return end
		local entInfo, i
		for i in pairs(self.EntInfo) do
			entInfo = self.EntInfo[i]
			if entInfo.Ent && entInfo.Ent:IsValid() then
				if entInfo.Ent:GetPhysicsObject():IsMoveable() then	
					entInfo.Ent:GetPhysicsObject():EnableMotion( false )
					entInfo.Ent:GetPhysicsObject():Sleep()
					entInfo.Ent:GetPhysicsObject():EnableDrag( false )
	           			if self.AlterWeight == 1 then entInfo.Ent:GetPhysicsObject():SetMass(50000) end
				end
			else table.remove(self.EntInfo, i)
			end
		end
	end
   	self.Entity:NextThink(CurTime())
	self:ShowOutput()
   	return true
end 

function ENT:BuildDupeInfo()
	local info = self.BaseClass.BuildDupeInfo(self) or {}
	
	local OffWeight
	
	info.EntInfo = {}
	local entInfo, i
	for i in pairs(self.EntInfo) do
		entInfo = self.EntInfo[i]
		if (entInfo.Ent) and (entInfo.Ent:IsValid()) then
			table.insert(info.EntInfo,{	Ent = entInfo.Ent:EntIndex(),
								OffWeight = entInfo.OffWeight})
		end
	end
	info.IsActivated = self.Activated
	info.AlterWeight = self.AlterWeight
	
	return info
end 

function ENT:ApplyDupeInfo(ply, ent, info, GetEntByID)
	self.BaseClass.ApplyDupeInfo(self, ply, ent, info, GetEntByID)
	
	self.PreviousValue = self.Inputs.Activate.Value
	
	self.EntInfo = {}
	local tempEnt
	local entInfo, i
	for i in pairs(info.EntInfo) do
		entInfo = info.EntInfo[i]
		if (entInfo.Ent) then
			tempEnt = GetEntByID(entInfo.Ent)
			if (!tempEnt) then
				tempEnt = ents.GetByIndex(entInfo.Ent)
			end
			table.insert(self.EntInfo,{	Ent = tempEnt,
								OffWeight = entInfo.OffWeight})
		end
	end
	self.Activated = info.IsActivated
	self.AlterWeight = info.AlterWeight
end