TOOL.Category		= "Wire - Physics"
TOOL.Name			= "Freezer"
TOOL.Command		= nil
TOOL.ConfigName		= ""

if CLIENT then
	
    language.Add( "Tool_wire_freezer_name", "Freezer Tool (Wire)" )
    language.Add( "Tool_wire_freezer_desc", "Makes a controllable freezer" )
    language.Add( "Tool_wire_freezer_0", "Primary: Click on the first entity to be frozen" )
    language.Add( "Tool_wire_freezer_1", "Left Click to select additional entities, Right click to place the controller" )
    language.Add( "Tool_wire_freezer_2", "Uhh, what? BUG LOL. Hit Reload to reset" )
    language.Add( "Tool_wire_freezer_weight", "Increase frozen weight (recommended)" )
    language.Add( "Tool_wire_freezer_affectall", "Freeze all constrained entities" )
    language.Add( "Tool_wire_freezer_model", "Choose a model:" )
	language.Add( "undone_wirefreezer", "Undone Wire Freezer" )
	
end

local usermodels = {
	["models/jaanus/wiretool/wiretool_siren.mdl"] = {},
	["models/jaanus/wiretool/wiretool_beamcaster.mdl"] = {}
}

TOOL.ClientConVar[ "Model" ] = "models/jaanus/wiretool/wiretool_siren.mdl"
TOOL.ClientConVar[ "AlterWeight" ] = "1"
TOOL.ClientConVar[ "AffectAll" ] = "0"


function TOOL:LeftClick( trace )
	if !trace.Entity:IsValid() || trace.Entity:IsPlayer() then return end
	if CLIENT then return true end
	
	local iNum = self:NumObjects()

	local Phys = trace.Entity:GetPhysicsObjectNum( trace.PhysicsBone )

	local i
	for i = 1, iNum, 1 do
		if (self:GetEnt(i) == trace.Entity) then return end
	end
	
	self:SetObject( iNum + 1, trace.Entity, trace.HitPos, Phys, trace.PhysicsBone, trace.HitNormal )

	local OffWeight = trace.Entity:GetPhysicsObject():GetMass()

	if iNum == 0 then self.EntInfo = {} end
	
	table.insert(self.EntInfo,{OffWeight})
		
	self:SetStage(1)
	return true
end

function TOOL:RightClick( trace )
	if !trace.Entity:IsValid() || trace.Entity:IsPlayer() then return end
	
	local iNum = self:NumObjects()
	if ( iNum != 0 ) then
			
		if ( CLIENT ) then
			self:ClearObjects()
			return true
		end
		
		local ply = self:GetOwner()

		local alterweight = self:GetClientNumber("AlterWeight")
		local affectall = self:GetClientNumber("AffectAll")
		local model = self:GetClientInfo("Model")
	
		if ( trace.Entity:IsValid() && trace.Entity:GetClass() == "gmod_wire_freezer" && trace.Entity:GetTable().pl == ply ) then
			//trace.Entity:Setup(alterweight, affectall)
			trace.Entity.AlterWeight = alterweight
			trace.Entity.AffectAll = affectall
			return true
		end
		
		// Attach Controller with a weld constraint
		local Ang = trace.HitNormal:Angle()
		Ang.pitch = Ang.pitch + 90
		local controller = MakeWireFreezerController( ply, trace.HitPos, Ang, model )
		local min = controller:OBBMins()
		controller:SetPos( trace.HitPos - trace.HitNormal * min.z )
		local weld = WireLib.Weld(controller, trace.Entity, trace.PhysicsBone, true)

		controller.AlterWeight = alterweight
		controller.AffectAll = affectall
		//table.Merge(controller:GetTable(), {alterweight = alterweight, pl = pl})
		
		// Send info over to the controller
		local controllerInfo = {}
		local i
		for i = 1, iNum, 1 do
			table.insert(controllerInfo,{Ent = self:GetEnt(i),
										OffWeight = self.EntInfo[i][1]})
		end
		
		// format : { Ent, OffWeight }
		controller:SendVars( controllerInfo )
		
		undo.Create("WireFreezer")
			undo.AddEntity( controller )
			if (trace.Entity:IsValid()) then
				undo.AddEntity( weld )
			end
			undo.SetPlayer( ply )
		undo.Finish()
		
		self:ClearObjects()
		self:SetStage(0)
		
	else return end
	
	return true
	
end


if SERVER then
	
	function MakeWireFreezerController( pl, Pos, Ang, model)
		local controller = ents.Create("gmod_wire_freezer")
		
		controller:SetPos( Pos )
		controller:SetAngles( Ang )
		local model2 = "models/jaanus/wiretool/wiretool_siren.mdl"
	
		controller:SetModel( Model(model or model2) )
		
		controller:Spawn()
		controller:SetPlayer(pl)
		controller.pl = pl
		
		return controller
	end
	duplicator.RegisterEntityClass("gmod_wire_freezer", MakeWireFreezerController, "Pos", "Ang", "Model")
		
end

function TOOL.BuildCPanel(panel)
	panel:AddControl( "Header", { Text = "#Tool_wire_freezer_name", Description = "#Tool_wire_freezer_desc" } )
	panel:AddControl( "PropSelect", { Label = "#Tool_wire_freezer_model",
									 ConVar = "wire_freezer_Model",
									 Category = "Wire Freezers",
									 Models = usermodels } )
	panel:CheckBox("#Tool_wire_Freezer_affectall", "wire_freezer_AffectAll")
	panel:CheckBox("#Tool_wire_Freezer_weight", "wire_freezer_AlterWeight")
	panel:AddControl("Label", {Text = "Temporarily increases frozen entity's weight, to strengthen constraints (like physgun-freeze)"})
end